(*  Title:      HOL/Bali/AxExample.thy
    ID:         $Id: AxExample.thy,v 1.4 2002/02/22 10:26:45 schirmer Exp $
    Author:     David von Oheimb
    License:    GPL (GNU GENERAL PUBLIC LICENSE)
*)

header {* Example of a proof based on the Bali axiomatic semantics *}

theory AxDecimalExample = AxSem1 + DecimalExample:

ML {*
fun inst1_tac s t = instantiate_tac [(s,t)];
val ax_tac = REPEAT o rtac allI THEN'
             resolve_tac(thm "ax_Skip"::thm "ax_StatRef"::thm "ax_MethdN"::
                         thm "ax_Alloc"::thm "ax_Alloc_Arr"::
                         thm "ax_SXAlloc_Normal"::
                         funpow 7 tl (thms "ax_derivs.intros"))
*}

declare split_paired_All [simp del] split_paired_Ex [simp del]
ML_setup {*
simpset_ref() := simpset() delloop "split_all_tac";
claset_ref () := claset () delSWrapper "split_all_tac"
*}


lemma ax_LVar2: "G,A\<turnstile>{Normal P} LVar vn=\<succ> {\<lambda> Y. Normal (\<lambda>s.. ((P\<down>=Var (lvar vn s)) Y))}"
apply (rule ax_derivs.LVar [THEN conseq1])
apply force
done


theorem oppose_spec:
"tprg,A\<turnstile>{Normal (\<lambda>s. locals (store s) (VName X)  = Some (Intg I)) }
       LVar (VName X) := Lit (Intg I')-\<succ>
       {\<lambda>Y. Normal (\<lambda>s. locals (store s) (VName X) = Some (Intg I'))}"
apply (rule Ass)
apply (rule ax_LVar2 [THEN conseq2])
apply  clarify
apply  assumption
apply (rule allI, rule Lit [THEN conseq1])
apply (clarsimp simp add: lvar_def assign_def Let_def)
done

apply  simp
apply  (rule LVar [THEN conseq1, 
        where ?Q = "\<lambda> Y. Normal (\<lambda> s. locals (store s) (VName X) = Some (Intg I) \<and> 
                         Y = (In2 (lvar (VName X) (store s))))"])
apply simp
apply (rule allI, rule Lit [THEN conseq1])
apply (clarsimp simp add: lvar_def assign_def Let_def)
apply clarsimp
apply  (simp add: lvar_def)

lemma methd_oppose: 
  "methd tprg Decimal \<lparr>name = oppose, parTs = []\<rparr> = Some (Decimal, mhead.extend oppose_mhead 
                    \<lparr>mbody = \<lparr>lcls=[],
                              stmt= Expr ({Decimal, Decimal, True}this..intPart:=
                         UnOp UMinus (Acc ({Decimal, Decimal, True}this..intPart))) \<rparr> \<rparr>)"
sorry

theorem oppose_spec:
"tprg,A\<turnstile>{Normal ((\<lambda>s. let field_map=(values (lookup_obj (store s) (the (locals (store s) This)))) in 
                      the (field_map (Inl intPart_fspec))=Intg I ) 
                  \<and>. initd Decimal \<and>. (\<lambda> s. locals (store s) This  = Some object)) }
       Methd Decimal \<lparr>name=oppose,parTs=[]\<rparr>-\<succ>
       {\<lambda>Y. Normal 
            (\<lambda>s. let field_map = values (lookup_obj (snd s) (the (locals (store s) This)))
                 in the (field_map (Inl intPart_fspec)) = Intg (- I) )}"
apply (rule ax_MethdN)
apply (rule ax_thin [OF _ empty_subsetI])
apply (simp (no_asm) add: body_def2 methd_oppose mhead.extend_def)
apply ( rule ax_derivs.Body (* Body *))
 apply (rule ax_derivs.Done [THEN conseq1])
 apply simp
 apply (intro allI impI,assumption)
apply (rule ax_derivs.Expr [THEN conseq1])
 prefer 2
 apply (simp,intro allI impI, assumption)
apply (rule ax_derivs.Ass)
 apply (rule ax_derivs.FVar)
  apply (rule ax_derivs.Done [THEN conseq1])
  apply (simp,intro allI impI,assumption)
 apply (rule ax_derivs.Acc [THEN conseq1])
  prefer 2
  apply (simp,intro allI impI, assumption)
 apply (rule ax_derivs.LVar [THEN conseq1] )
 apply simp
  (* apply (simp add: lvar_def fvar_def2) *)
 
 prefer 2
 apply (rule allI, rule ax_derivs.UnOp)
 apply (rule Acc)
 apply (rule FVar)
  apply (rule ax_derivs.Done [THEN conseq1])
  apply simp
  apply clarify
  apply assumption

 apply (rule Acc)  
 apply (rule LVar [THEN conseq1])
 apply simp
 apply (intro allI impI)
 apply (erule conjE)
 apply (simp)
 apply simp

    prefer 2
    apply(rule Comp)
     prefer 2
     apply(rule Comp)
      prefer 2
      apply(rule Jmp)
      apply(rule Expr)
      apply(rule Ass)
       prefer 2
       apply(intro strip)
       apply (rule_tac P' = "Normal ?P" in conseq1)
        apply(rule Acc)
        apply (rule conseq1)
         apply(rule LVar)
         apply (tactic {* inst1_tac "Q17"  "\<lambda> a vs l. (\<lambda>Y st. ( Normal
                               (abupd (\<lambda>a. Some (Jump Ret)) .;
                                (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                             let field_map =
                                                   values
                                                    (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                             in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                                the (field_map (Inl decPart_fspec)) = Intg (- D))
                                          ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                         fst ((set_lvars l) (abupd (absorb Ret) s)) =
                                         None)\<leftarrow>\<diamondsuit>)) Y (assign (snd (the_In2 Y)) (fst (lvar This (snd st))) st))"*})

theorem ax_test: "tprg,A\<turnstile>
              {Normal (\<lambda>s. let field_map=(values (lookup_obj (store s) (the (locals (store s) (EName (VNam d)))))) in 
               the (field_map (Inl intPart_fspec))=Intg I \<and> the (field_map (Inl decPart_fspec))=Intg D) } 
                         {Decimal, ClassT Decimal, IntVir}!!d\<cdot>oppose({[]}[])-\<succ> 
              {(\<lambda>Y s. let field_map=(values (lookup_obj (store s) (the (locals (store s) (EName (VNam d)))))) in 
               normal s \<and> the (field_map (Inl intPart_fspec))=Intg (-I) \<and> the (field_map (Inl decPart_fspec))=Intg (-D)) }"
apply (rule_tac C = "Decimal" in ax_Call_known_DynT)
(*4*)
apply (unfold DynT_prop_def,simp)
(*3*)
prefer 3
apply (rule ax_derivs.Acc)
apply (rule conseq1)
apply (rule ax_derivs.LVar)
apply (simp)
apply clarify
apply assumption
apply (simp add: Let_def)
apply (rule allI)
apply (rule impI)
apply (case_tac "(lvar (VName d) (snd s))")
apply clarsimp
apply simp
apply rules
apply clarsimp

theorem ax_test: "tprg,(A::(int \<times> int) triple set)\<turnstile>
              {Normal (\<lambda>Y (x,s) (I,D). let field_map=(values (lookup_obj s (the (locals s (EName (VNam d)))))) in 
               the (field_map (Inl intPart_fspec))=Intg I \<and> the (field_map (Inl decPart_fspec))=Intg D) } 
                         {Decimal, ClassT Decimal, IntVir}!!d\<cdot>oppose({[]}[])-\<succ> 
              {Normal (\<lambda>Y (x,s) (I,D). let field_map=(values (lookup_obj s (the (locals s (EName (VNam d)))))) in 
               the (field_map (Inl intPart_fspec))=Intg (-I) \<and> the (field_map (Inl decPart_fspec))=Intg (-D)) }"
apply (rule_tac C = "Decimal" in ax_Call_known_DynT)
(*4*)
apply (unfold DynT_prop_def,simp)
(*3*)
prefer 3
apply (rule ax_derivs.Acc)
apply (rule conseq1)
apply (rule ax_derivs.LVar)
apply simp
apply (tactic {* inst1_tac "Q" "\<lambda>Y (x, s) (I, D).
               let field_map = values (lookup_obj s (the (locals s (VName d))))
               in the (field_map (Inl intPart_fspec)) = Intg I \<and> the (field_map (Inl decPart_fspec)) = Intg D" *})
apply simp
apply (rule allI)+
apply (case_tac "(lvar (VName d) b)")
apply simp
apply force
apply (rule ax_derivs.LVar)

apply (intro strip)



apply (rule_tac P' = "Normal ?P" in conseq1)
 apply (rule ax_MethdN)
 apply (rule ax_thin [OF _ empty_subsetI])
 apply     (simp (no_asm) add: body_def2)
 apply ( rule ax_derivs.Body (* Body *))
  prefer 2
  apply (simp add: methd_oppose)
  apply (simp add: mhead.extend_def)
  apply   (rule_tac P' = "Normal ?P" in conseq1)
   apply(rule Comp)
    prefer 2
    apply(rule Comp)
     prefer 2
     apply(rule Comp)
      prefer 2
      apply(rule Jmp)
      apply(rule Expr)
      apply(rule Ass)
       prefer 2
       apply(intro strip)
       apply (rule_tac P' = "Normal ?P" in conseq1)
        apply(rule Acc)
        apply (rule conseq1)
         apply(rule LVar)
         apply (tactic {* inst1_tac "Q17"  "\<lambda> a vs l. (\<lambda>Y st. ( Normal
                               (abupd (\<lambda>a. Some (Jump Ret)) .;
                                (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                             let field_map =
                                                   values
                                                    (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                             in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                                the (field_map (Inl decPart_fspec)) = Intg (- D))
                                          ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                         fst ((set_lvars l) (abupd (absorb Ret) s)) =
                                         None)\<leftarrow>\<diamondsuit>)) Y (assign (snd (the_In2 Y)) (fst (lvar This (snd st))) st))"*})
apply clarsimp
apply (case_tac "(lvar This ba)")
apply clarsimp
apply clarsimp
apply (case_tac "(lvar This ba)")
apply clarsimp
apply(simp add:Let_def assign_def)
(*8*)
apply (rule ax_derivs.LVar)
apply(rule Expr)
apply(rule Ass)
prefer 2
apply(intro strip)
apply (rule_tac P' = "Normal ?P" in conseq1)
 apply(rule ax_derivs.UnOp)
apply(rule ax_derivs.Acc)
apply(rule ax_derivs.FVar)
prefer 2
apply(rule ax_derivs.Acc)
apply(rule ax_derivs.LVar)
apply (rule conseq1)
apply(rule ax_derivs.Done)
apply clarify
apply simp

lemma methd_oppose: 
  "methd tprg Decimal \<lparr>name = oppose, parTs = []\<rparr> = Some (Decimal, mhead.extend oppose_mhead 
                    \<lparr>mbody = \<lparr>lcls=[],
                              stmt= Expr ({Decimal, Decimal, True}this..intPart:=
                         UnOp UMinus (Acc ({Decimal, Decimal, True}this..intPart)));;
                           Expr ({Decimal, Decimal, True}this..decPart:=
                         UnOp UMinus (Acc ({Decimal, Decimal, True}this..decPart)));;
                          Return this \<rparr> \<rparr>)"
sorry


lemma "(\<lambda>(v, f). (assign b v .;
                  Normal ((abupd (\<lambda>a. Some (Jump Ret)) .;
                           (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                        let field_map = values (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                        in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                           the (field_map (Inl decPart_fspec)) = Intg (- D))
                                     ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                    fst ((set_lvars l) (abupd (absorb Ret) s)) = None)\<leftarrow>\<diamondsuit>)\<leftarrow>\<diamondsuit>))\<leftarrow>In1 v)
        (lvar This ba) (In2 (lvar This ba)) = f"
apply (case_tac "lvar This ba")
apply clarsimp
(*
apply simp
apply clarify
apply(rule conjI)
 apply clarify
apply (simp add:Let_def)
apply(rule conjI)*)
sorry




theorem ax_test: "tprg,(A::'a triple set)\<turnstile>
              {Normal (\<lambda>Y s Z::'a. let field_map=(values (lookup_obj (store s) (the (locals (store s) (EName (VNam d)))))) in 
               the (field_map (Inl intPart_fspec))=Intg I \<and> the (field_map (Inl decPart_fspec))=Intg D) } 
                         {Decimal, ClassT Decimal, IntVir}!!d\<cdot>oppose({[]}[])-\<succ> 
              {Normal (\<lambda>Y s Z::'a. let field_map=(values (lookup_obj (store s) (the (locals (store s) (EName (VNam d)))))) in 
               the (field_map (Inl intPart_fspec))=Intg (-I) \<and> the (field_map (Inl decPart_fspec))=Intg (-D)) }"
apply (rule_tac C = "Decimal" in ax_Call_known_DynT)
(*4*)
apply (unfold DynT_prop_def,simp)
(*3*)
prefer 3
apply (rule ax_derivs.Acc)
apply (rule conseq1)
apply (rule ax_derivs.LVar)
apply simp
apply (rule allI)
apply (rule impI)
apply (case_tac "(lvar (VName d) (snd s))")
apply clarsimp
apply simp
apply rules
apply clarsimp

theorem ax_test: "tprg,(A::(int \<times> int) triple set)\<turnstile>
              {Normal (\<lambda>Y (x,s) (I,D). let field_map=(values (lookup_obj s (the (locals s (EName (VNam d)))))) in 
               the (field_map (Inl intPart_fspec))=Intg I \<and> the (field_map (Inl decPart_fspec))=Intg D) } 
                         {Decimal, ClassT Decimal, IntVir}!!d\<cdot>oppose({[]}[])-\<succ> 
              {Normal (\<lambda>Y (x,s) (I,D). let field_map=(values (lookup_obj s (the (locals s (EName (VNam d)))))) in 
               the (field_map (Inl intPart_fspec))=Intg (-I) \<and> the (field_map (Inl decPart_fspec))=Intg (-D)) }"
apply (rule_tac C = "Decimal" in ax_Call_known_DynT)
(*4*)
apply (unfold DynT_prop_def,simp)
(*3*)
prefer 3
apply (rule ax_derivs.Acc)
apply (rule conseq1)
apply (rule ax_derivs.LVar)
apply simp
apply (tactic {* inst1_tac "Q" "\<lambda>Y (x, s) (I, D).
               let field_map = values (lookup_obj s (the (locals s (VName d))))
               in the (field_map (Inl intPart_fspec)) = Intg I \<and> the (field_map (Inl decPart_fspec)) = Intg D" *})
apply simp
apply (rule allI)+
apply (case_tac "(lvar (VName d) b)")
apply simp
apply force
apply (rule ax_derivs.LVar)

apply (intro strip)



apply (rule_tac P' = "Normal ?P" in conseq1)
 apply (rule ax_MethdN)
 apply (rule ax_thin [OF _ empty_subsetI])
 apply     (simp (no_asm) add: body_def2)
 apply ( rule ax_derivs.Body (* Body *))
  prefer 2
  apply (simp add: methd_oppose)
  apply (simp add: mhead.extend_def)
  apply   (rule_tac P' = "Normal ?P" in conseq1)
   apply(rule Comp)
    prefer 2
    apply(rule Comp)
     prefer 2
     apply(rule Comp)
      prefer 2
      apply(rule Jmp)
      apply(rule Expr)
      apply(rule Ass)
       prefer 2
       apply(intro strip)
       apply (rule_tac P' = "Normal ?P" in conseq1)
        apply(rule Acc)
        apply (rule conseq1)
         apply(rule LVar)
         apply (tactic {* inst1_tac "Q17"  "\<lambda> a vs l. (\<lambda>Y st. ( Normal
                               (abupd (\<lambda>a. Some (Jump Ret)) .;
                                (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                             let field_map =
                                                   values
                                                    (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                             in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                                the (field_map (Inl decPart_fspec)) = Intg (- D))
                                          ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                         fst ((set_lvars l) (abupd (absorb Ret) s)) =
                                         None)\<leftarrow>\<diamondsuit>)) Y (assign (snd (the_In2 Y)) (fst (lvar This (snd st))) st))"*})
apply clarsimp
apply (case_tac "(lvar This ba)")
apply clarsimp
apply clarsimp
apply (case_tac "(lvar This ba)")
apply clarsimp
apply(simp add:Let_def assign_def)
(*8*)
apply (rule ax_derivs.LVar)
apply(rule Expr)
apply(rule Ass)
prefer 2
apply(intro strip)
apply (rule_tac P' = "Normal ?P" in conseq1)
 apply(rule ax_derivs.UnOp)
apply(rule ax_derivs.Acc)
apply(rule ax_derivs.FVar)
prefer 2
apply(rule ax_derivs.Acc)
apply(rule ax_derivs.LVar)
apply (rule conseq1)
apply(rule ax_derivs.Done)
apply clarify
apply simp
term "fvar Decimal True decPart a ..;
                                (\<lambda>Var:(v,
                                 f):. (\<lambda>Val:v:. (\<lambda>Val:v:. assign (snd vf) v .;
 Normal
  (\<lambda>s.. (\<lambda>Y st. (Normal
                  (abupd (\<lambda>a. Some (Jump Ret)) .;
                   (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                let field_map = values (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                   the (field_map (Inl decPart_fspec)) = Intg (- D))
                             ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                            fst ((set_lvars l) (abupd (absorb Ret) s)) = None)\<leftarrow>\<diamondsuit>))
                 Y (assign (snd (the_In2 Y)) (fst (lvar This (snd st)))
                     st))\<leftarrow>In2 (lvar Result s))\<leftarrow>\<diamondsuit>)\<leftarrow>In1 (eval_unop UMinus v))\<leftarrow>In1 v)"

apply clarsimp
apply(simp add:Let_def)
term "fst (lvar This s)"
 term  "assign (snd vf) v .;
                              Normal
                               (abupd (\<lambda>a. Some (Jump Ret)) .;
                                (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                             let field_map =
                                                   values
                                                    (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                             in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                                the (field_map (Inl decPart_fspec)) = Intg (- D))
                                          ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                         fst ((set_lvars l) (abupd (absorb Ret) s)) =
                                         None)\<leftarrow>\<diamondsuit>)"
term
"(\<lambda>Y st. ( Normal
                               (abupd (\<lambda>a. Some (Jump Ret)) .;
                                (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                             let field_map =
                                                   values
                                                    (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                             in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                                the (field_map (Inl decPart_fspec)) = Intg (- D))
                                          ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                         fst ((set_lvars l) (abupd (absorb Ret) s)) =
                                         None)\<leftarrow>\<diamondsuit>)) Y (assign (snd (the_In2 Y)) (fst (lvar This s)) st))"
apply simp

apply clarify
apply(rule conjI)
 prefer 2 apply simp

term 
Q a vs l = \<lambda>vf. (\<lambda>Val:v:. assign (snd vf) v .;
                 Normal (abupd (\<lambda>a. Some (Jump Ret)) .;
                         (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                      let field_map = values (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                      in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                         the (field_map (Inl decPart_fspec)) = Intg (- D))
                                   ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                  fst ((set_lvars l) (abupd (absorb Ret) s)) = None)\<leftarrow>\<diamondsuit>)\<leftarrow>\<diamondsuit>)
term 
"(\<lambda>vf. (\<lambda>Val:v:. assign (snd vf) v .;
                 Normal (abupd (\<lambda>a. Some (Jump Ret)) .;
                         (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                      let field_map = values (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                      in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                         the (field_map (Inl decPart_fspec)) = Intg (- D))
                                   ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                  fst ((set_lvars l) (abupd (absorb Ret) s)) = None)\<leftarrow>\<diamondsuit>)\<leftarrow>\<diamondsuit>)) vf"
       apply (rule_tac P' = "Normal ?P" in conseq1)
        apply(rule Acc)
        apply (rule conseq1)
         apply(rule LVar)
apply clarify
apply simp
apply clarify
term "(\<lambda>(v\<Colon>val, f\<Colon>[val, state] \<Rightarrow> state).
           (assign b v .;
            Normal ((abupd (\<lambda>a\<Colon>abopt. Some (Jump Ret)) .;
                     (\<lambda>(Y\<Colon>vals) (s\<Colon>state) u\<Colon>int \<times> int.
                         (\<lambda>(x\<Colon>abopt, s\<Colon>st) (I\<Colon>int, D\<Colon>int).
                             let field_map\<Colon>vn \<Rightarrow> val option =
                                   values (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                             in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                the (field_map (Inl decPart_fspec)) = Intg (- D))
                          ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                         fst ((set_lvars l) (abupd (absorb Ret) s)) = None)\<leftarrow>\<diamondsuit>)\<leftarrow>\<diamondsuit>))\<leftarrow>In1 v)"
term vvar

term "\<lambda>Var:(v\<Colon>val,
         f\<Colon>[val, state]
           \<Rightarrow> state):. (\<lambda>Val:(v\<Colon>val):. assign (snd vf) v .;
                                      Normal (abupd (\<lambda>a\<Colon>abopt. Some (Jump Ret)) .;
                                              (\<lambda>(Y\<Colon>vals) (s\<Colon>state) u\<Colon>int \<times> int.
                                                  (\<lambda>(x\<Colon>abopt, s\<Colon>st) (I\<Colon>int, D\<Colon>int).
                                                      let field_map\<Colon>vn \<Rightarrow> val option =
                                                            values (the
       (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                                      in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                                         the (field_map (Inl decPart_fspec)) = Intg (- D))
                                                   ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                                  fst ((set_lvars l) (abupd (absorb Ret) s)) = None)\<leftarrow>\<diamondsuit>)\<leftarrow>\<diamondsuit>)\<leftarrow>In1 v"
        apply (rule conseq1)
         apply(rule LVar)
apply clarify
apply simp
apply clarify
apply (case_tac "lvar This ba")
apply(rule conjI)
 prefer 2
 apply force
apply (simp (no_asm_use))
apply clarify
apply simp
apply(rule conjI)
apply (simp (no_asm_use))
term "(lvar This ba)"
term lvar
apply (tactic {* inst1_tac "Q17"  ""*})
apply (simp (no_asm))

apply(simp add:subst_res_def)
         apply (tactic {* inst1_tac "Q17"  "\<lambda> xa xb xc. (\<lambda>Var:vf . (\<lambda>Var:(v,
                     f):. (\<lambda>Val:v:. assign (snd vf) v .;
                                    Normal (abupd (\<lambda>a. Some (Jump Ret)) .;
                                            (\<lambda>Y s u. (\<lambda>(x, s) (I, D).
                                                         let field_map =
                                                               values (the (globs s (Inl (the_Addr (the (locals s (VName d)))))))
                                                         in the (field_map (Inl intPart_fspec)) = Intg (- I) \<and>
                                                            the (field_map (Inl decPart_fspec)) = Intg (- D))
                                                      ((set_lvars l) (abupd (absorb Ret) s)) u \<and>
                                                     fst ((set_lvars l) (abupd (absorb Ret) s)) =
                                                     None)\<leftarrow>\<diamondsuit>)\<leftarrow>\<diamondsuit>)\<leftarrow>In1 v))"*})
apply clarsimp

apply clarify
apply simp
apply force
prefer 8



apply simp



apply(rule Expr)
apply      (simp add:tprg_def)
apply      (tactic "ax_tac 1")
apply      (tactic "ax_tac 1") (* Ass *)
prefer 2
apply       (rule ax_subst_Var_allI)
apply       (tactic {* inst1_tac "P'27" "\<lambda>a vs l vf. ?PP a vs l vf\<leftarrow>?x \<and>. ?p" *})
apply       (rule allI)
apply       (tactic {* simp_tac (simpset() delloop "split_all_tac" delsimps [thm "peek_and_def2"]) 1 *})
apply       (rule ax_derivs.Abrupt)
apply      (simp (no_asm))
apply      (tactic "ax_tac 1" (* FVar *))
apply       (tactic "ax_tac 2", tactic "ax_tac 2", tactic "ax_tac 2")
apply      (tactic "ax_tac 1")

apply (rule ax_derivs.Methd)




oops
theorem "G,({}::'a triple set)\<turnstile>{Normal P} {accC,statT,mode}eee\<cdot>mn({pTs}args)-\<succ> {(S\<Colon>'a assn)}"
apply(rule ax_derivs.Call)

sorry

\<lbrakk>(?G\<Colon>prog),(?A\<Colon>?'a triple set)\<turnstile>{Normal (?P\<Colon>assn ?'a)} (?e\<Colon>expr)-\<succ> {?Q\<Colon>assn ?'a};
   \<forall>a\<Colon>val. ?G,?A\<turnstile>{?Q\<leftarrow>In1 a} (?args\<Colon>expr list)\<doteq>\<succ> {(?R\<Colon>val \<Rightarrow> assn ?'a) a};
   \<forall>(a\<Colon>val) (vs\<Colon>val list) (invC\<Colon>qtname) (declC\<Colon>qtname) l\<Colon>lname \<Rightarrow> val option.
      ?G,?A\<turnstile>{?R a\<leftarrow>In3 vs \<and>.
             (\<lambda>s\<Colon>state.
                 declC =
                 invocation_declclass ?G (?mode\<Colon>inv_mode) (snd s) a (?statT\<Colon>ref_ty)
                  \<lparr>name = ?mn\<Colon>mname, parTs = ?pTs\<Colon>ty list\<rparr> \<and>
                 invC = invocation_class ?mode (snd s) a ?statT \<and> l = locals (snd s)) ;.
             init_lvars ?G declC \<lparr>name = ?mn, parTs = ?pTs\<rparr> ?mode a vs \<and>.
             (\<lambda>s\<Colon>state. normal s \<longrightarrow> ?G\<turnstile>?mode\<rightarrow>invC\<preceq>?statT)}
      Methd declC \<lparr>name = ?mn, parTs = ?pTs\<rparr>-\<succ> {set_lvars l .; (?S\<Colon>assn ?'a)}\<rbrakk>
\<Longrightarrow> ?G,?A\<turnstile>{Normal ?P} {(?accC\<Colon>qtname),?statT,?mode}?e\<cdot>?mn( {?pTs}?args)-\<succ> {?S}

term "d"

theorem ax_test: "tprg,({}::'a triple set)\<turnstile> 
  {Normal (\<lambda>Y s Z::'a. True)} {Decimal,ClassT Decimal, IntVir}test\<cdot>oppose({[]}[])-\<succ> {\<lambda>Y s Z. True}"


theorem ax_test: "tprg,({}::'a triple set)\<turnstile> 
  {Normal (\<lambda>Y s Z::'a. heap_free four s \<and> \<not>initd Base s \<and> \<not> initd Ext s)} 
  {Decimal,ClassT Decimal, IntVir}test\<cdot>oppose({[]}[])-\<succ> {\<lambda>Y s Z. abrupt s = Some (Xcpt (Std IndOutBound))}"


section



constdefs
  arr_inv :: "st \<Rightarrow> bool"
 "arr_inv \<equiv> \<lambda>s. \<exists>obj a T el. globs s (Stat Base) = Some obj \<and>
                              values obj (Inl (arr, Base)) = Some (Addr a) \<and>
                              heap s a = Some \<lparr>tag=Arr T 2,values=el\<rparr>"

lemma arr_inv_new_obj: 
"\<And>a. \<lbrakk>arr_inv s; new_Addr (heap s)=Some a\<rbrakk> \<Longrightarrow> arr_inv (gupd(Inl a\<mapsto>x) s)"
apply (unfold arr_inv_def)
apply (force dest!: new_AddrD2)
done

lemma arr_inv_set_locals [simp]: "arr_inv (set_locals l s) = arr_inv s"
apply (unfold arr_inv_def)
apply (simp (no_asm))
done

lemma arr_inv_gupd_Stat [simp]: 
  "Base \<noteq> C \<Longrightarrow> arr_inv (gupd(Stat C\<mapsto>obj) s) = arr_inv s"
apply (unfold arr_inv_def)
apply (simp (no_asm_simp))
done

lemma ax_inv_lupd [simp]: "arr_inv (lupd(x\<mapsto>y) s) = arr_inv s"
apply (unfold arr_inv_def)
apply (simp (no_asm))
done


declare split_if_asm [split del]
declare lvar_def [simp]

ML {*
fun inst1_tac s t = instantiate_tac [(s,t)];
val ax_tac = REPEAT o rtac allI THEN'
             resolve_tac(thm "ax_Skip"::thm "ax_StatRef"::thm "ax_MethdN"::
                         thm "ax_Alloc"::thm "ax_Alloc_Arr"::
                         thm "ax_SXAlloc_Normal"::
                         funpow 7 tl (thms "ax_derivs.intros"))
*}


theorem ax_test: "tprg,({}::'a triple set)\<turnstile> 
  {Normal (\<lambda>Y s Z::'a. heap_free four s \<and> \<not>initd Base s \<and> \<not> initd Ext s)} 
  .test [Class Base]. {\<lambda>Y s Z. abrupt s = Some (Xcpt (Std IndOutBound))}"
apply (unfold test_def arr_viewed_from_def)
apply (tactic "ax_tac 1" (*;;*))
defer
apply  (tactic "ax_tac 1" (* Try *))
defer
apply    (tactic {* inst1_tac "Q1" 
                 "\<lambda>Y s Z. arr_inv (snd s) \<and> tprg,s\<turnstile>catch SXcpt NullPointer" *})
prefer 2
apply    simp
apply   (rule_tac P' = "Normal (\<lambda>Y s Z. arr_inv (snd s))" in conseq1)
prefer 2
apply    clarsimp
apply   (rule_tac Q' = "(\<lambda>Y s Z. ?Q Y s Z)\<leftarrow>=False\<down>=\<diamondsuit>" in conseq2)
prefer 2
apply    simp
apply   (tactic "ax_tac 1" (* While *))
prefer 2
apply    (rule ax_impossible [THEN conseq1], clarsimp)
apply   (rule_tac P' = "Normal ?P" in conseq1)
prefer 2
apply    clarsimp
apply   (tactic "ax_tac 1")
apply   (tactic "ax_tac 1" (* AVar *))
prefer 2
apply    (rule ax_subst_Val_allI)
apply    (tactic {* inst1_tac "P'21" "\<lambda>u a. Normal (?PP a\<leftarrow>?x) u" *})
apply    (simp del: avar_def2 peek_and_def2)
apply    (tactic "ax_tac 1")
apply   (tactic "ax_tac 1")
      (* just for clarification: *)
apply   (rule_tac Q' = "Normal (\<lambda>Var:(v, f) u ua. fst (snd (avar tprg (Intg 2) v u)) = Some (Xcpt (Std IndOutBound)))" in conseq2)
prefer 2
apply    (clarsimp simp add: split_beta)
apply   (tactic "ax_tac 1" (* FVar *))
apply    (tactic "ax_tac 2" (* StatRef *))
apply   (rule ax_derivs.Done [THEN conseq1])
apply   (clarsimp simp add: arr_inv_def inited_def in_bounds_def)
defer
apply  (rule ax_SXAlloc_catch_SXcpt)
apply  (rule_tac Q' = "(\<lambda>Y (x, s) Z. x = Some (Xcpt (Std NullPointer)) \<and> arr_inv s) \<and>. heap_free two" in conseq2)
prefer 2
apply   (simp add: arr_inv_new_obj)
apply  (tactic "ax_tac 1") 
apply  (rule_tac C = "Ext" in ax_Call_known_DynT)
apply     (unfold DynT_prop_def)
apply     (simp (no_asm))
apply    (intro strip)
apply    (rule_tac P' = "Normal ?P" in conseq1)
apply     (tactic "ax_tac 1" (* Methd *))
apply     (rule ax_thin [OF _ empty_subsetI])
apply     (simp (no_asm) add: body_def2)
apply     (tactic "ax_tac 1" (* Body *))
(* apply       (rule_tac [2] ax_derivs.Abrupt) *)
defer
apply      (simp (no_asm))
apply      (tactic "ax_tac 1")
apply      (tactic "ax_tac 1") (* Ass *)
prefer 2
apply       (rule ax_subst_Var_allI)
apply       (tactic {* inst1_tac "P'27" "\<lambda>a vs l vf. ?PP a vs l vf\<leftarrow>?x \<and>. ?p" *})
apply       (rule allI)
apply       (tactic {* simp_tac (simpset() delloop "split_all_tac" delsimps [thm "peek_and_def2"]) 1 *})
apply       (rule ax_derivs.Abrupt)
apply      (simp (no_asm))
apply      (tactic "ax_tac 1" (* FVar *))
apply       (tactic "ax_tac 2", tactic "ax_tac 2", tactic "ax_tac 2")
apply      (tactic "ax_tac 1")
apply     clarsimp
apply     (tactic {* inst1_tac "R14" "\<lambda>a'. Normal ((\<lambda>Vals:vs (x, s) Z. arr_inv s \<and> inited Ext (globs s) \<and> a' \<noteq> Null \<and> hd vs = Null) \<and>. heap_free two)" *})
prefer 5
apply     (rule ax_derivs.Done [THEN conseq1], force)
apply    force
apply   (rule ax_subst_Val_allI)
apply   (tactic {* inst1_tac "P'33" "\<lambda>u a. Normal (?PP a\<leftarrow>?x) u" *})
apply   (simp (no_asm) del: peek_and_def2)
apply   (tactic "ax_tac 1")
prefer 2
apply   (rule ax_subst_Val_allI)
apply    (tactic {* inst1_tac "P'4" "\<lambda>aa v. Normal (?QQ aa v\<leftarrow>?y)" *})
apply    (simp del: peek_and_def2)
apply    (tactic "ax_tac 1")
apply   (tactic "ax_tac 1")
apply  (tactic "ax_tac 1")
apply  (tactic "ax_tac 1")
(* end method call *)
apply (simp (no_asm))
    (* just for clarification: *)
apply (rule_tac Q' = "Normal ((\<lambda>Y (x, s) Z. arr_inv s \<and> (\<exists>a. the (locals s (VName e)) = Addr a \<and> obj_class (the (globs s (Inl a))) = Ext \<and> 
 invocation_declclass tprg IntVir s (the (locals s (VName e))) (ClassT Base)  
     \<lparr>name = foo, parTs = [Class Base]\<rparr> = Ext)) \<and>. initd Ext \<and>. heap_free two)"
  in conseq2)
prefer 2
apply  clarsimp
apply (tactic "ax_tac 1")
apply (tactic "ax_tac 1")
defer
apply  (rule ax_subst_Var_allI)
apply  (tactic {* inst1_tac "P'14" "\<lambda>u vf. Normal (?PP vf \<and>. ?p) u" *})
apply  (simp (no_asm) del: split_paired_All peek_and_def2)
apply  (tactic "ax_tac 1" (* NewC *))
apply  (tactic "ax_tac 1" (* ax_Alloc *))
     (* just for clarification: *)
apply  (rule_tac Q' = "Normal ((\<lambda>Y s Z. arr_inv (store s) \<and> vf=lvar (VName e) (store s)) \<and>. heap_free tree \<and>. initd Ext)" in conseq2)
prefer 2
apply   (simp add: invocation_declclass_def dynmethd_def)
apply   (unfold dynlookup_def)
apply   (simp add: dynmethd_Ext_foo)
apply   (force elim!: arr_inv_new_obj atleast_free_SucD atleast_free_weaken)
     (* begin init *)
apply  (rule ax_InitS)
apply     force
apply    (simp (no_asm))
apply   (tactic {* simp_tac (simpset() delloop "split_all_tac") 1 *})
apply   (rule ax_Init_Skip_lemma)
apply  (tactic {* simp_tac (simpset() delloop "split_all_tac") 1 *})
apply  (rule ax_InitS [THEN conseq1] (* init Base *))
apply      force
apply     (simp (no_asm))
apply    (unfold arr_viewed_from_def)
apply    (rule allI)
apply    (rule_tac P' = "Normal ?P" in conseq1)
apply     (tactic {* simp_tac (simpset() delloop "split_all_tac") 1 *})
apply     (tactic "ax_tac 1")
apply     (tactic "ax_tac 1")
apply     (rule_tac [2] ax_subst_Var_allI)
apply      (tactic {* inst1_tac "P'29" "\<lambda>vf l vfa. Normal (?P vf l vfa)" *})
apply     (tactic {* simp_tac (simpset() delloop "split_all_tac" delsimps [split_paired_All, thm "peek_and_def2"]) 2 *})
apply      (tactic "ax_tac 2" (* NewA *))
apply       (tactic "ax_tac 3" (* ax_Alloc_Arr *))
apply       (tactic "ax_tac 3")
apply      (tactic {* inst1_tac "P" "\<lambda>vf l vfa. Normal (?P vf l vfa\<leftarrow>\<diamondsuit>)" *})
apply      (tactic {* simp_tac (simpset() delloop "split_all_tac") 2 *})
apply      (tactic "ax_tac 2")
apply     (tactic "ax_tac 1" (* FVar *))
apply      (tactic "ax_tac 2" (* StatRef *))
apply     (rule ax_derivs.Done [THEN conseq1])
apply     (tactic {* inst1_tac "Q22" "\<lambda>vf. Normal ((\<lambda>Y s Z. vf=lvar (VName e) (snd s)) \<and>. heap_free four \<and>. initd Base \<and>. initd Ext)" *})
apply     (clarsimp split del: split_if)
apply     (frule atleast_free_weaken [THEN atleast_free_weaken])
apply     (drule initedD)
apply     (clarsimp elim!: atleast_free_SucD simp add: arr_inv_def)
apply    force
apply   (tactic {* simp_tac (simpset() delloop "split_all_tac") 1 *})
apply   (rule ax_triv_Init_Object [THEN peek_and_forget2, THEN conseq1])
apply     (rule wf_tprg)
apply    clarsimp
apply   (tactic {* inst1_tac "P22" "\<lambda>vf. Normal ((\<lambda>Y s Z. vf = lvar (VName e) (snd s)) \<and>. heap_free four \<and>. initd Ext)" *})
apply   clarsimp
apply  (tactic {* inst1_tac "PP" "\<lambda>vf. Normal ((\<lambda>Y s Z. vf = lvar (VName e) (snd s)) \<and>. heap_free four \<and>. Not \<circ> initd Base)" *})
apply  clarsimp
     (* end init *)
apply (rule conseq1)
apply (tactic "ax_tac 1")
apply clarsimp
done

(*
while (true) {
  if (i) {throw xcpt;}
  else i=j
}
*)
lemma Loop_Xcpt_benchmark: 
 "Q = (\<lambda>Y (x,s) Z. x \<noteq> None \<longrightarrow> the_Bool (the (locals s i))) \<Longrightarrow>  
  G,({}::'a triple set)\<turnstile>{Normal (\<lambda>Y s Z::'a. True)}  
  .lab1\<bullet> While(Lit (Bool True)) (If(Acc (LVar i)) (Throw (Acc (LVar xcpt))) Else
        (Expr (Ass (LVar i) (Acc (LVar j))))). {Q}"
apply (rule_tac P' = "Q" and Q' = "Q\<leftarrow>=False\<down>=\<diamondsuit>" in conseq12)
apply  safe
apply  (tactic "ax_tac 1" (* Loop *))
apply   (rule ax_Normal_cases)
prefer 2
apply    (rule ax_derivs.Abrupt [THEN conseq1], clarsimp simp add: Let_def)
apply   (rule conseq1)
apply    (tactic "ax_tac 1")
apply   clarsimp
prefer 2
apply  clarsimp
apply (tactic "ax_tac 1" (* If *))
apply  (tactic 
  {* inst1_tac "P'21" "Normal (\<lambda>s.. (\<lambda>Y s Z. True)\<down>=Val (the (locals s i)))" *})
apply  (tactic "ax_tac 1")
apply  (rule conseq1)
apply   (tactic "ax_tac 1")
apply  clarsimp
apply (rule allI)
apply (rule ax_escape)
apply auto
apply  (rule conseq1)
apply   (tactic "ax_tac 1" (* Throw *))
apply   (tactic "ax_tac 1")
apply   (tactic "ax_tac 1")
apply  clarsimp
apply (rule_tac Q' = "Normal (\<lambda>Y s Z. True)" in conseq2)
prefer 2
apply  clarsimp
apply (rule conseq1)
apply  (tactic "ax_tac 1")
apply  (tactic "ax_tac 1")
prefer 2
apply   (rule ax_subst_Var_allI)
apply   (tactic {* inst1_tac "P'29" "\<lambda>b Y ba Z vf. \<lambda>Y (x,s) Z. x=None \<and> snd vf = snd (lvar i s)" *})
apply   (rule allI)
apply   (rule_tac P' = "Normal ?P" in conseq1)
prefer 2
apply    clarsimp
apply   (tactic "ax_tac 1")
apply   (rule conseq1)
apply    (tactic "ax_tac 1")
apply   clarsimp
apply  (tactic "ax_tac 1")
apply clarsimp
done

end

